/**************************************************************************
* iptrk - ip tracker
* Copyright (C) 2003 Jason Nunn <jsno@leal.com.au>
* Darwin, NT, Australia.
* Originally developed for Arafura Connect (Dec 2000 - Mar 2003)
* Donated to GPL before liquidation.
*
* =======================================================================
* maintenance code (watch private addresses and networks)
*
**************************************************************************/
#include <curses.h>
#include "defs.h"
#include "lib.p"
#include "iptrk.p"

PRIVATE watch_private_t *wp;
PRIVATE int             done, port_found;

/**************************************************************************
*
**************************************************************************/
PRIVATE void test_port(treap_t *t)
{
  void sch(treap_t *t)
  {
    port_t *n;

    if(t == NULL || port_found)
      return;

    test_port(t->l);

    n = TREAP_ENTRY(t);
    if(wp->service == n->port.port.d)
    {
      port_found = 1;
      return;
    }

    test_port(t->r);
  }

 /*
  * start
  */
  if(wp->service == 0)
  {
    port_found = 1;
    return;
  }
  sch(t);
}

/**************************************************************************
*
**************************************************************************/
PRIVATE void scan_tree(treap_t *t)
{
  iptrk_t *n;

  if(t == NULL || done)
    return;

  scan_tree(t->l);

  n = TREAP_ENTRY(t);

  if(wp->addr.addr == (n->addr.addr.d & wp->addr.mask))
  {
    our_net_t *s_net = NULL;

    if(n->addr.addr.s == 0xffffffff) /*if clipped, then ignore test*/
      s_net = (void *)0x1;
    else
      get_our_net(n->addr.addr.s, &s_net);
    if(s_net == NULL)
    {
      int c = 0;

      port_found = 0;
      if(wp->prot == PROT_ALL)
      {
        c++;
        if(n->tcp_port_ll != NULL)
          test_port(n->tcp_port_ll);
        if(port_found)
          c++;
        else if(n->udp_port_ll != NULL)
        {
          test_port(n->udp_port_ll);
          if(port_found)
            c++;
        }
      }
      else
      {
        if(wp->prot == PROT_TCP && n->tcp_port_ll != NULL)
        {
          c++;
          test_port(n->tcp_port_ll);
        }
        else if(wp->prot == PROT_UDP && n->udp_port_ll != NULL)
        {
          c++;
          test_port(n->udp_port_ll);
        }
        else if(wp->prot == PROT_OTH && n->oth_port_ll != NULL)
        {
          c++;
          test_port(n->oth_port_ll);
        }
        if(port_found)
          c++;
      }

      if(c >= 2)
      {
        char           str[STR_LEN + 1],
                       email_body[STR_LEN_HUGE];
        struct in_addr in;

        in.s_addr = htonl(n->addr.addr.d);
        sprintf(str, " private watch %s (#%d) trig",
          inet_ntoa(in),
          wp->no);
        log_m('I', NULL, str);
        compose_watch_email_body(email_body, wp->str, inet_ntoa(in));
        email_operator(str, email_body);
        done = 1;
      }
    }
  }

  scan_tree(t->r);
}

/**************************************************************************
***************************************************************************
* PRIVATE WATCH
***************************************************************************
**************************************************************************/
PUBLIC void do_watch_private(void)
{
  ll_t *ll;

  log_m('I', NULL, " doing private watches..");
  ll = boot.watch_private_ll;
  for(;;)
  {
    wp = ll_read_entry(&ll);
    if(wp == NULL)
      break;

    if(!test_zone(wp->zone))
      continue;

    done = 0;
    scan_tree(watch_bt);
  }
}
